pythonocc使用 AIS_Animation类进行动画仿真

box = BRepPrimAPI_MakeBox(10, 20, 30).Shape()  # 创建一个大小为10x20x30的立方体
display, start_display, add_menu, add_function_to_menu = init_display()  # 初始化显示窗口
Abox = display.DisplayShape(box, update=True)[0]  # 在显示窗口中显示立方体
context = AIS_InteractiveContext(display.Viewer)  # 创建交互上下文
ax1 = gp_Ax1(gp_Pnt(0, 0, 0), gp_Dir(0, 0, 1))  # 创建一个以原点为中心,z轴为方向的坐标系
angle1 = 45  # 旋转角度
trf1 = gp_Trsf()  # 创建变换矩阵trf1
trf2 = gp_Trsf()  # 创建变换矩阵trf2
trf2.SetRotation(ax1, angle1)  # 对变换矩阵trf2进行旋转
name = TCollection_AsciiString("Animation1")  # 动画名称
animation = AIS_Animation(name)  # 创建动画对象
box_ais = AIS_AnimationObject(name, context, Abox, trf1, trf2)  # 创建立方体的动画对象
box_ais.SetOwnDuration(10)  # 设置立方体动画的持续时间
animation.Add(box_ais)  # 将立方体动画添加到动画对象中
duration = animation.Duration()  # 获取动画的持续时间
animation.StartTimer(0, 1, True)  # 启动动画计时器
while (not animation.IsStopped()):  # 动画未停止时
    animation.UpdateTimer()  # 更新动画计时器
    context.UpdateCurrentViewer()  # 更新当前视图
start_display()  # 开始显示动画

#以上代码贡献于湘潭大学研一学生
  • 0
    点赞
  • 3
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

宁波莱布尼茨信息技术有限公司

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值